		
#define	Float	highp float
#define	Float2	highp vec2
#define	Float3	highp vec3
#define	Float4	highp vec4
#define	Float3x3	highp mat3
#define	Float4x4	highp mat4
#define	Half	mediump float
#define	Half2	mediump vec2
#define	Half3	mediump vec3
#define	Half4	mediump vec4
#define	Fixed	lowp float
#define	Fixed2	lowp vec2
#define	Fixed3	lowp vec3
#define	Fixed4	lowp vec4
#define	saturate(x)	clamp(x,0.0,1.0)
#define	lerp(a,b,w)	mix(a,b,w)
#define	tex1D		texture1D
#define	tex2D		texture2D
#define	tex2DProj	texture2DProj

		
uniform sampler2D	smpDiffuseMap;
			
uniform sampler2D	smpNormalMap;
			
uniform Fixed4	u_ambient_fs;
//uniform Fixed4	u_sun_diff1_fs;
//uniform	Fixed4	u_sun_spec_fs;
//uniform Fixed4	u_m_light_diff_fs;
//uniform Fixed4	u_m_light_spec_fs;
//uniform	Float4	u_m_light_pos_fs;
		
uniform Half4	u_fog_color;
		
varying Half4	v_Color;
		
varying Half4	v_NMLightDir;
varying Half3	v_NMLightDiff;
		
varying Half2	v_TexDiff;
			
varying Half	v_FogFactor;
		
void main()
{
		
	Fixed4 c = tex2D(smpDiffuseMap, v_TexDiff.xy);
	Fixed texAlpha = c.a;
			
	Half4 nc = tex2D(smpNormalMap,v_TexDiff.xy);
	Half3 nor = nc.rgb*2.0-1.0;
			
	// spec factor
				
	Half specFactor = texAlpha;
					
	Half3 spec = vec3(0,0,0);
	Half NdotL;
	Half4 color = v_Color;
	
	NdotL = max(0.0,dot(v_NMLightDir.xyz,nor));
	Half3 lc = v_NMLightDiff.rgb * v_NMLightDir.w * NdotL + u_ambient_fs.rgb;
			
	if (NdotL > 0.0)
		spec = max((max(lc.rgb,0.0)-0.8)*5.0,0.0) * v_NMLightDiff.rgb;
	spec *= specFactor;
			
	color.rgb += lc;	
		
	c *= color;
		
	c.rgb += spec;
		
	gl_FragColor = vec4(lerp(u_fog_color.rgb,c.rgb,v_FogFactor),c.a);
					
}
	