
#define	Float	highp float
#define	Float2	highp vec2
#define	Float3	highp vec3
#define	Float4	highp vec4
#define	Float3x3	highp mat3
#define	Float4x4	highp mat4
#define	Half	mediump float
#define	Half2	mediump vec2
#define	Half3	mediump vec3
#define	Half4	mediump vec4
#define	Fixed	lowp float
#define	Fixed2	lowp vec2
#define	Fixed3	lowp vec3
#define	Fixed4	lowp vec4
#define	saturate(x)	clamp(x,0.0,1.0)
#define	lerp(a,b,w)	mix(a,b,w)
#define	tex1D		texture1D
#define	tex2D		texture2D
		
#define	MAX_BONE_COUNT	40
#define	MAX_BATCH_COUNT	40

		
uniform Float4x4	u_tm_wvp;
			
uniform Float4x4	u_tm_world;
			
uniform Float4x4	u_tm_inv_view;
		
// Lighting
			
uniform Float4	u_ambient;
			
uniform Float3	u_sun_dir;
uniform Float4	u_sun_diff1;
				
uniform Float4	u_point_light_param;// x:pl_cnt y:sp_cnt
#define	POINT_LIGHT_COUNT	(int(u_point_light_param.x))
uniform Float4	u_point_light_pos_array[8];
uniform Float4	u_point_light_col_array[8];
				
uniform Half4	u_fog_param;
		
attribute Float3	a_Pos;
			
attribute Half3	a_Nor;
			
attribute Half2	a_Tex0;
			
varying Half4	v_Color;
			
varying Half2	v_TexDiff;
				
varying Half	v_FogFactor;
			
void main()
		
{
		
	Float4 pos = vec4(a_Pos.xyz,1.0);
				
	Half3 nor = a_Nor;
				
	gl_Position = u_tm_wvp * pos;
				
	Float3 worldPos	= (u_tm_world * pos).xyz;
				
	Fixed4 vc = vec4(1.0,1.0,1.0,1.0);
			
	Fixed4 color = u_ambient;
				
	Half3 N = normalize(mat3(u_tm_world)*nor);
			
	Half NdotL;
			
	int lightCnt = POINT_LIGHT_COUNT;
	for (int i=0; i<lightCnt; i++)
	{
		Float4 light_pos = u_point_light_pos_array[i];
		Half3 dir = light_pos.xyz - worldPos.xyz;
		Half dist = length(dir);
		dir /= dist;
		Half radius = light_pos.w;
		dist = min(dist,radius) / radius;
		dist = 1.0 - dist*dist;
		NdotL = max(0.0, dot(N,dir));
		color.rgb += u_point_light_col_array[i].rgb * (NdotL * dist);
	}
			
	Half3 SL = -u_sun_dir;
					
	NdotL = max(0.0, dot(N,SL));
	color.rgb += u_sun_diff1.rgb*NdotL*vc.rgb;
					
	v_Color = color;
		
	v_TexDiff.xy = a_Tex0;
				
	v_FogFactor = saturate((u_fog_param.y-gl_Position.z)*u_fog_param.z);
		
}
	