
#define	Float	highp float
#define	Float2	highp vec2
#define	Float3	highp vec3
#define	Float4	highp vec4
#define	Float3x3	highp mat3
#define	Float4x4	highp mat4
#define	Half	mediump float
#define	Half2	mediump vec2
#define	Half3	mediump vec3
#define	Half4	mediump vec4
#define	Fixed	lowp float
#define	Fixed2	lowp vec2
#define	Fixed3	lowp vec3
#define	Fixed4	lowp vec4
#define	saturate(x)	clamp(x,0.0,1.0)
#define	lerp(a,b,w)	mix(a,b,w)
#define	tex1D		texture1D
#define	tex2D		texture2D
		
#define	MAX_BONE_COUNT	40
#define	MAX_BATCH_COUNT	40

		
uniform Float4x4	u_tm_wvp;
			
uniform Float4x4	u_tm_world;
			
uniform Float4x4	u_tm_wv;
			
uniform Float4x4	u_tm_view;
		
uniform Float4x4	u_tm_inv_view;
		
uniform Float4x4	u_tm_world_array[MAX_BONE_COUNT];
		
// Lighting
			
uniform Float4	u_ambient;
			
uniform Half4	u_rim_color;
			
uniform Half4	u_fog_param;
		
attribute Float3	a_Pos;
			
attribute Half3	a_Nor;
			
attribute Half3	a_Tag;
attribute Half3	a_Binor;
			
attribute Half2	a_Tex0;
			
attribute Half4	a_BlendIndex;
attribute Half4	a_BlendWeight;
			
varying Half4	v_Color;
			
//varying Half3	v_SunDir;
//varying Half	v_Dist;
//varying Half3	v_MainLightDir;
varying Half4	v_NMLightDir;
varying Half3	v_NMLightDiff;
			
varying Half2	v_TexDiff;
				
varying Half	v_FogFactor;
			
void main()
		
{
		
	mediump ivec4 boneIndex = ivec4(a_BlendIndex);
	Half4  boneWeights = vec4(a_BlendWeight);
	Float4x4 boneMatrix = u_tm_world_array[boneIndex.x];
	Float4 pos = boneMatrix * vec4(a_Pos.xyz,1.0) * boneWeights.x;
				
	Float3x3 rotBoneMatrix = mat3(boneMatrix);
	Half3 nor = rotBoneMatrix * a_Nor * boneWeights.x;
				
	Half3 tag = rotBoneMatrix * a_Tag * boneWeights.x;
	Half3 binor = rotBoneMatrix * a_Binor * boneWeights.x;
				
	for (int i=1; i < 2; i++)
	{
		boneIndex = boneIndex.yzwx;
		boneWeights = boneWeights.yzwx;
		boneMatrix = u_tm_world_array[boneIndex.x];
		pos += boneMatrix * vec4(a_Pos.xyz,1.0) * boneWeights.x;
				
		rotBoneMatrix = mat3(boneMatrix);
		nor += rotBoneMatrix * a_Nor * boneWeights.x;
				
		tag += rotBoneMatrix * a_Tag * boneWeights.x;
		binor += rotBoneMatrix * a_Binor * boneWeights.x;
				
	}
			
	gl_Position = u_tm_wvp * pos;
				
	Fixed4 vc = vec4(1.0,1.0,1.0,1.0);
			
	Fixed4 color = u_ambient;
				
	Float3 viewSpaceNor = normalize(mat3(u_tm_wv) * nor);
	Float rl = 1.0-(viewSpaceNor.z*viewSpaceNor.z);
	color.rgb += u_rim_color.rgb*(rl*rl);;
			
	Half3 N = normalize(mat3(u_tm_world)*nor);
			
	Half NdotL;
			
	Float3 wT = normalize(mat3(u_tm_world)*tag);
	Float3 wB = normalize(mat3(u_tm_world)*binor);
	Float3 wN = normalize(mat3(u_tm_world)*nor);
	Float3x3 sunTagSpaceXform = mat3(wT,wB,wN);
				
	v_NMLightDir = vec4(vec3(0.0,0.0,1.0)*sunTagSpaceXform,1.0);
	v_NMLightDiff = vec3(0.0,0.0,0.0);
					
	v_Color = color;
		
	v_TexDiff.xy = a_Tex0;
				
	v_FogFactor = saturate((u_fog_param.y-gl_Position.z)*u_fog_param.z);
		
}
	